/*
 * Hax_TiledBalloonRenderer.m
 *
 * Copyright (c) 2006 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*#import "iChat.h"
#import "Chax.h"
#import "MethodSwizzle.h"

@implementation TiledBalloonRenderer (Hax_hax_hax)

+ (void)load
{
	MethodSwizzleClass([self class], @selector(balloonForColor:fromMe:), @selector(hax_balloonForColor:fromMe:));
	MethodSwizzle([self class], @selector(paragraphStyleForMessage:), @selector(hax_paragraphStyleForMessage:));
	MethodSwizzle([self class], @selector(_thoughtBubbleForMessage:), @selector(hax_thoughtBubbleForMessage:));
	MethodSwizzle([self class], @selector(_boundsOfPictureForMessage:inRect:), @selector(hax_boundsOfPictureForMessage:inRect:));
	MethodSwizzle([self class], @selector(_boundsOfBalloonForMessage:inRect:), @selector(hax_boundsOfBalloonForMessage:inRect:));
	MethodSwizzle([self class], @selector(boundsOfMessage:withTextBounds:), @selector(hax_boundsOfMessage:withTextBounds:));
}

+ (id)hax_balloonForColor:(id)fp8 fromMe:(BOOL)fp12
{
	return [self hax_balloonForColor:fp8 fromMe:!fp12];
}

- (id)hax_paragraphStyleForMessage:(id)fp8
{
	NSMutableParagraphStyle *style = [[self hax_paragraphStyleForMessage:fp8] mutableCopy];
	NSTextAlignment alignment = [style alignment];
	if (alignment == NSRightTextAlignment) {
		[style setAlignment:NSLeftTextAlignment];
	} else if (alignment == NSLeftTextAlignment) {
		[style setAlignment:NSRightTextAlignment];
	}
	return [style autorelease];
}

- (id)hax_thoughtBubbleForMessage:(id)fp8
{
	return [fp8 fromMe] ? [NSImage imageNamed:@"ThoughtBubble_left"] : [NSImage imageNamed:@"ThoughtBubble_right"];
}

- (NSRect)hax_boundsOfPictureForMessage:(id)fp8 inRect:(NSRect)fp12
{
	id msg;
	
	if ([fp8 fromMe]) {
		msg = [[[InstantMessage alloc] initWithSender:nil time:[NSDate date] string:@"" incomingFile:nil flags:0 error:NULL] autorelease];
	} else {
		msg = [InstantMessage fromMeOnService:[[fp8 sender] service] withText:[[[NSAttributedString alloc] initWithString:@""] autorelease] outgoingFile:nil flags:0];
	}
	
	NSRect rect = [self hax_boundsOfPictureForMessage:msg inRect:fp12];
	return rect;
}

- (NSRect)hax_boundsOfBalloonForMessage:(id)fp8 inRect:(NSRect)fp12;
{
	NSRect rect = [self hax_boundsOfBalloonForMessage:fp8 inRect:fp12];
	rect.origin.x += [fp8 fromMe] ? -16 : 5;
	return rect;
}

- (NSRect)hax_boundsOfMessage:(id)fp8 withTextBounds:(NSRect)fp12
{
	NSRect rect = [self hax_boundsOfMessage:fp8 withTextBounds:fp12];
	rect.origin.x = 0;
	return rect;
}

@end
*/